
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "_lib.h"
#include "inlib.h"

extern	int		(**SystemFunc)();

int		(*LibErrorExec)(char*) = NULL ;
int		(*LibWarningExec)(char*) = NULL ;
#ifdef DYNAMIC
Library	**LibAry ;
#endif

/*	Cȕ	*/
int		__LibraryInit( func, lib )
void	*func ;
Library	**lib ;
{
#ifdef DYNAMIC
	SystemFunc = (int(**)())func ;
	LibAry = lib ;
#endif
	LibErrorExec = NULL ;
	LibWarningExec = NULL ;
	return 0 ;
}

#ifdef DYNAMIC
/*	Cuԍ𓾂	*/
int		LibraryGet( name )
char	*name ;
{
	int		i ;
	Library	**lib = LibAry ;

	if ( lib == NULL )
		return 0 ;

	for( i = 1 ; i < MAX_LIBS ; i++ )
	{
		if ( lib[i] != NULL && strcmp( lib[i]->name, name ) == 0 )
		{
			return i ;
		}
	}
	return 0 ;
}

/*	Cu𓾂	*/
Library	*LibraryGetInfo( no )
int		no ;
{
	Library	**lib = LibAry ;

	if ( lib == NULL )
		return NULL ;
	else
		return lib[no] ;
}
#endif

/*	G[bZ[W̕\	*/
int		MessageError( msg )
char	*msg ;
{
	if ( LibErrorExec == NULL )
	{
		printf( "%s\n", msg );
		exit( 1 );
		return -1 ;
	}
	else
		return (*LibErrorExec)( msg );
}

/*	xbZ[W̕\	*/
int		MessageWarning( msg )
char	*msg ;
{
	if ( LibWarningExec == NULL )
	{
		printf( "%s\n", msg );
		return 0 ;
	}
	else
		return (*LibWarningExec)( msg );
}

/*	G[bZ[W\[`̕ύX	*/
void	MessageSet( err, warn )
void	*err, *warn ;
{
	LibErrorExec = err ;
	LibWarningExec = warn ;
}

